﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.IO;
using System.Runtime.Serialization;
using System.Xml;

namespace Logger
{
    public static class SerializeExtensions
    {
        public static T DeserializeObject<T>(this string filename)
        {
            using (var filestream = new FileStream(filename, FileMode.Open))
            using (var reader = 
                XmlDictionaryReader.CreateTextReader(filestream, new XmlDictionaryReaderQuotas()))
            {
                var deserializer = new DataContractSerializer(typeof(T));
                T deserializedObject = (T)deserializer.ReadObject(reader, false);
                reader.Close();
                filestream.Close();
                return deserializedObject;
            }
        }

        public static void SerializeObject<T>(this T toSerialize, string filename)
        {
            var serializer = new DataContractSerializer(typeof(T));
            using (var filestream = new FileStream(filename, FileMode.Create))
            {
                serializer.WriteObject(filestream, toSerialize);
                filestream.Flush();
                filestream.Close();
            }
        }
    }
}
