﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PacketProcessor.Alarms
{
    class Alarm : IAlarm
    {
        public Alarm()
        {
            this.Description = string.Empty;
        }

        public int AlarmNumber { get; set; }
        public string Description { get; set; }
        public byte Channel { get; set; }
        public int ThresholdWatts { get; set; }

        public bool IsActive(TimeSlice timeSlice)
        {
            if(timeSlice == null) throw new ArgumentNullException("timeSlice");
            var thresholdWattSeconds = this.ThresholdWatts * TimeSlice.SECONDS_PER_SLICE;
            return timeSlice.WattSeconds(this.Channel) >= thresholdWattSeconds;
        }

        public override string ToString()
        {
            return string.Format("Alarm {0:000}: Ch{1} >= {2}W, {3}",
                this.AlarmNumber,
                this.Channel,
                this.ThresholdWatts,
                this.Description);
        }
    }
}
