﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Mail;
using System.Net;

namespace PacketProcessor.Email
{
    public class GmailEmailer
    {
        private readonly string emailAddress;
        private readonly string password;

        public GmailEmailer(
            string emailAddress,
            string password)
        {
            if (emailAddress == null) throw new ArgumentNullException("emailAddress");
            if (password == null) throw new ArgumentNullException("password");
            this.emailAddress = emailAddress;
            this.password = password;
        }

        public bool TryEmail(
            string subject,
            string body)
        {
            try
            {
                sendEmail(subject, body);
                return true;
            }
            catch (SmtpException)
            {
                return false;
            }
        }

        private void sendEmail(
            string subject,
            string body)
        {
            var fromAddress = new MailAddress(this.emailAddress, "PowerCruncher");
            var toAddress = new MailAddress(this.emailAddress);

            var smtp = new SmtpClient
            {
                Host = "smtp.gmail.com",
                Port = 587,
                EnableSsl = true,
                DeliveryMethod = SmtpDeliveryMethod.Network,
                UseDefaultCredentials = false,
                Credentials = new NetworkCredential(fromAddress.Address, this.password),
                Timeout = 20000
            };
            using (var message = new MailMessage(fromAddress, toAddress)
            {
                Subject = subject,
                Body = body
            })
            {
                smtp.Send(message);
            }
        }
    }
}
