﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Uploader
{
    public interface ISerialPortController : IDisposable
    {
        /// <summary>
        /// Sends a byte array via a serial port, and then
        /// waits for a response of a given length.
        /// </summary>
        /// <param name="send">Bytes to send</param>
        /// <param name="receiveLength">Bytes to receive</param>
        /// <returns>Received bytes (will be of length specified)</returns>
        byte[] SendReceive(byte[] send, int receiveLength);

        void OpenPort();
        void ClosePortIfOpen();
    }
}
